"use strict";var $game=null;var Game=function(){function Game(){this._display=new ROT.Display({width:80,height:25});this._log=new MessageLog;this._screen=null;this._scheduler=new ROT.Scheduler.Simple;this._engine=new ROT.Engine(this._scheduler);this._player=null;this.bindEventToScreen("keydown");this.bindEventToScreen("keyup");this.bindEventToScreen("keypress");this.switchScreen(Screen_Title)}var _proto=Game.prototype;_proto.display=function display(){return this._display};_proto.log=function log(){return this._log};_proto.bindEventToScreen=function bindEventToScreen(event){window.addEventListener(event,function(e){if(this._screen){this.maybePreventDefault(event,e);this._screen.handleInput(event,e)}}.bind(this))};_proto.maybePreventDefault=function maybePreventDefault(event,e){if(event==="keydown"||event==="keyup"||event==="keypress"){switch(e.keyCode){case ROT.KEYS.VK_END:case ROT.KEYS.VK_DOWN:case ROT.KEYS.VK_PAGE_DOWN:case ROT.KEYS.VK_LEFT:case ROT.KEYS.VK_RIGHT:case ROT.KEYS.VK_HOME:case ROT.KEYS.VK_UP:case ROT.KEYS.VK_PAGE_UP:case ROT.KEYS.VK_SPACE:case ROT.KEYS.VK_ENTER:case ROT.KEYS.VK_QUESTION_MARK:case ROT.KEYS.VK_SLASH:case ROT.KEYS.VK_DIVIDE:case ROT.KEYS.VK_ESCAPE:e.preventDefault();break}}};_proto.refresh=function refresh(){this.display().clear();this._screen.render(this.display())};_proto.switchScreen=function switchScreen(screen){if(this._screen!==null){this._screen.exit()}this.display().clear();this._screen=null;if(screen!==null){this._screen=new screen}if(this._screen!==null){this._screen.enter();this.refresh()}};_proto.engine=function engine(){return this._engine};_proto.scheduler=function scheduler(){return this._scheduler};_proto.setPlayer=function setPlayer(p){this._player=p};_proto.player=function player(){return this._player};_proto.setDungeon=function setDungeon(d){this._dungeon=d};_proto.dungeon=function dungeon(){return this._dungeon};return Game}();window.onload=function(){$game=new Game;document.body.appendChild($game.display().getContainer())};"use strict";function _createForOfIteratorHelperLoose(o,allowArrayLike){var it=typeof Symbol!=="undefined"&&o[Symbol.iterator]||o["@@iterator"];if(it)return(it=it.call(o)).next.bind(it);if(Array.isArray(o)||(it=_unsupportedIterableToArray(o))||allowArrayLike&&o&&typeof o.length==="number"){if(it)o=it;var i=0;return function(){if(i>=o.length)return{done:true};return{done:false,value:o[i++]}}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}function _unsupportedIterableToArray(o,minLen){if(!o)return;if(typeof o==="string")return _arrayLikeToArray(o,minLen);var n=Object.prototype.toString.call(o).slice(8,-1);if(n==="Object"&&o.constructor)n=o.constructor.name;if(n==="Map"||n==="Set")return Array.from(o);if(n==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return _arrayLikeToArray(o,minLen)}function _arrayLikeToArray(arr,len){if(len==null||len>arr.length)len=arr.length;for(var i=0,arr2=new Array(len);i<len;i++){arr2[i]=arr[i]}return arr2}var Architect=function(){function Architect(options){options=options||{};this._height=options["height"]||25;this._width=options["width"]||80;this._style=options["style"]||"dungeon";this._minSteps=options["minSteps"]||Math.min(this._height,this._width)/3;this._spawnNear=options["spawnNear"]||null;this._encounterTable=options["encounterTable"]||null;this._enemyCount=options["enemyCount"]||20;this._itemCount=options["itemCount"]||8;this._map=null}var _proto=Architect.prototype;_proto.build=function build(){this.buildEmptyMap();switch(this._style){default:case"dungeon":this.buildDungeon();break;case"woods":this.buildWoods();break;case"boss":this.buildBossArena();break}this.populateMap();return this._map};_proto.buildEmptyMap=function buildEmptyMap(fill){fill=fill||Tile.nullTile;var map=new Array(this._width);for(var x=0;x<this._width;x++){map[x]=new Array(this._height).fill(fill)}this._map=new Game_Map(map)};_proto.buildDungeon=function buildDungeon(){var _this=this;var generator=new ROT.Map.Digger(this._width,this._height,{corridorLength:[2,8],dugPercentage:.35,timeLimit:5e3});generator.create(function(x,y,v){this._map.setTile(x,y,v?Tile.wallTile:Tile.floorTile)}.bind(this));var spawnRoom=null;var spawnDistance=Infinity;for(var _iterator=_createForOfIteratorHelperLoose(generator.getRooms()),_step;!(_step=_iterator()).done;){var room=_step.value;room.getDoors((function(x,y){_this._map.setTile(x,y,Tile.doorTile)}));var d2=this.distanceFromSpawnNear(room);if(d2<spawnDistance){spawnRoom=room;spawnDistance=d2}}var stairsUp=this.randomTileinRoom(spawnRoom);this._map.setTile(stairsUp.x,stairsUp.y,Tile.stairsUpTile);this._map.setEntry(stairsUp);this.placeStairsDown(stairsUp,{rooms:generator.getRooms()});this._map.setRooms(generator.getRooms())};_proto.randomTileinRoom=function randomTileinRoom(room){return{x:room.getLeft()+Math.floor(ROT.RNG.getUniform()*(room.getRight()-room.getLeft()+1)),y:room.getTop()+Math.floor(ROT.RNG.getUniform()*(room.getBottom()-room.getTop()+1))}};_proto.distanceFromSpawnNear=function distanceFromSpawnNear(room){if(!this._spawnNear){return 0}var x1=room.getLeft();var x2=room.getRight();var y1=room.getTop();var y2=room.getBottom();if(x1<=this._spawnNear.x&&x2>=this._spawnNear.x&&y1<=this._spawnNear.y&&y2>=this._spawnNear.y){return 0}var dx=ROT.Util.clamp(this._spawnNear.x,x1,x2)-this._spawnNear.x;var dy=ROT.Util.clamp(this._spawnNear.y,y1,y2)-this._spawnNear.y;return Math.sqrt(dx*dx+dy*dy)};_proto.buildBossArena=function buildBossArena(){var cell=new ROT.Map.Cellular(this._width,this._height,{born:[4,5,6,7,8],survive:[2,3,4,5]});cell.randomize(.85);for(var i=0;i<20;i++){cell.create()}var unconnected=new Set;var connected=new Set;cell.create((function(x,y,v){return v?null:unconnected.add(x+","+y)}));for(var _iterator2=_createForOfIteratorHelperLoose(unconnected),_step2;!(_step2=_iterator2()).done;){var k=_step2.value;var c=new Set;this.floodConnect(unconnected,c,k);if(c.size>connected.size){connected=c}}console.log("largest group",connected);this.buildEmptyMap(Tile.crystalWallTile);var spawnDistance=Infinity;var stairsUp=null;var spawnNear=this._spawnNear||{x:this._width/2,y:this._height/2};for(var _iterator3=_createForOfIteratorHelperLoose(connected),_step3;!(_step3=_iterator3()).done;){var _k=_step3.value;var parts=_k.split(",");var x=parseInt(parts[0]);var y=parseInt(parts[1]);this._map.setTile(x,y,Tile.floorTile);var dx=x-spawnNear.x;var dy=y-spawnNear.y;var d2=Math.sqrt(dx*dx+dy*dy);if(d2<spawnDistance){stairsUp={x:x,y:y};spawnDistance=d2}}this._map.setTile(stairsUp.x,stairsUp.y,Tile.stairsUpTile);this._map.setEntry(stairsUp)};_proto.floodConnect=function floodConnect(unconnected,connected,k){if(!unconnected.has(k))return;unconnected.delete(k);connected.add(k);for(var _iterator4=_createForOfIteratorHelperLoose(ROT.DIRS[4]),_step4;!(_step4=_iterator4()).done;){var d=_step4.value;var parts=k.split(",");var x=parseInt(parts[0]);var y=parseInt(parts[1]);var candidate=x+d[0]+","+(y+d[1]);if(unconnected.has(candidate)){this.floodConnect(unconnected,connected,candidate)}}};_proto.buildWoods=function buildWoods(){var _this2=this;var generator=new ROT.Map.Cellular(this._width,this._height);generator.randomize(.4);for(var i=0;i<3;i++){generator.create()}generator.create(function(x,y,v){this._map.setTile(x,y,v?Tile.treeTile:Tile.grassTile)}.bind(this));generator.connect(function(x,y,v){this._map.setTile(x,y,v?Tile.treeTile:Tile.grassTile)}.bind(this));var water=3;var beach=2;var pier_candidates=[];for(var x=0;x<this._width;x++){var dw=ROT.RNG.getUniform()-(water-3)*.2;if(dw<.3){water--;beach++}else if(dw>.7){water++;beach--}else{var db=ROT.RNG.getUniform()-(beach-2)*.3;if(db<.3)beach--;else if(db>.7)beach++}for(var y=0;y<water;y++){this._map.setTile(x,this._height-1-y,Tile.waterTile)}for(var _y=0;_y<beach;_y++){this._map.setTile(x,this._height-1-water-_y,Tile.sandTile)}if(beach==0){this._map.setTile(x,this._height-1-water,Tile.grassTile)}if(water>=3&&x>0&&x<this._width-1){pier_candidates.push({x:x,y:this._height-1-water})}}var centre=this._width/2;pier_candidates.sort((function(a,b){return _this2.pier_goodness(a)-_this2.pier_goodness(b)}));var spawn=pier_candidates.shift();if(!spawn){spawn={x:Math.round(this._width/2),y:this._height-4};this._map.setTile(spawn.x-1,spawn.y+1,Tile.waterTile);this._map.setTile(spawn.x+1,spawn.y+1,Tile.waterTile);this._map.setTile(spawn.x-1,spawn.y+2,Tile.waterTile);this._map.setTile(spawn.x+1,spawn.y+2,Tile.waterTile)}this._map.setEntry(spawn);this._map.setTile(spawn.x,spawn.y,Tile.bridgeTile);this._map.setTile(spawn.x,spawn.y+1,Tile.bridgeTile);this._map.setTile(spawn.x,spawn.y+2,Tile.bridgeTile);var dungeon=this.placeStairsDown(spawn,{top:2,left:2,width:this._width-4,height:this._height/2});this._map.blitTiles(Game_Map.fromString(" ... \n"+".###.\n"+".#>#.\n"+".....\n"+" .~. \n"+".~~~.\n"+"..~..\n"+" ... \n"),dungeon.x-2,dungeon.y-2)};_proto.pier_goodness=function pier_goodness(p){var score=0;if(this._map.tile(p.x-1,p.y)===Tile.sandTile)score+=1;if(this._map.tile(p.x+1,p.y)===Tile.sandTile)score+=1;if(this._map.tile(p.x-1,p.y+1)===Tile.sandTile)score+=10;if(this._map.tile(p.x+1,p.y+1)===Tile.sandTile)score+=10;score+=Math.abs(this._width/2-p.x)/this._width;return score};_proto.placeStairsDown=function placeStairsDown(spawn,options){var _this3=this;var top=options["top"]||0;var height=options["height"]||this._height;var left=options["left"]||0;var width=options["width"]||this._width;var rooms=options["rooms"]||null;var target=null;var astar=new ROT.Path.AStar(spawn.x,spawn.y,(function(x,y){return _this3._map.tile(x,y).passable()}));var limit=1e3;var _loop=function _loop(){limit--;if(!limit){console.warn("problem finding location for stairs down")}if(rooms){var room=rooms[Math.floor(ROT.RNG.getUniform()*rooms.length)];target=_this3.randomTileinRoom(room)}else{target={x:left+Math.floor(ROT.RNG.getUniform()*width),y:top+Math.floor(ROT.RNG.getUniform()*height)}}var distance=0;astar.compute(target.x,target.y,(function(x,y){return distance++}));if(distance<(limit>0?_this3._minSteps:1)){target=null}};while(!target){_loop()}this._map.setTile(target.x,target.y,Tile.stairsDownTile);this._map.setExit(target);return target};_proto.populateMap=function populateMap(){if(!this._encounterTable)return;for(var i=0;i<this._enemyCount;i++){var e=this._encounterTable.drawEntity();if(e){this._map.addEntityAtRandomPosition(e)}}for(var _i=0;_i<this._itemCount;_i++){var _e=this._encounterTable.drawItem();if(_e){this._map.addItemAtRandomPosition(_e)}}};return Architect}();"use strict";var Glyph=function(){function Glyph(options){this._char=options["char"]||" ";this._fg=options["foreground"]||"white";this._bg=options["background"]||"black"}var _proto=Glyph.prototype;_proto.char=function char(){return this._char};_proto.foreground=function foreground(){return this._fg};_proto.background=function background(){return this._bg};_proto.drawp=function drawp(){return[this.char(),this.foreground(),this.background()]};return Glyph}();"use strict";function _createForOfIteratorHelperLoose(o,allowArrayLike){var it=typeof Symbol!=="undefined"&&o[Symbol.iterator]||o["@@iterator"];if(it)return(it=it.call(o)).next.bind(it);if(Array.isArray(o)||(it=_unsupportedIterableToArray(o))||allowArrayLike&&o&&typeof o.length==="number"){if(it)o=it;var i=0;return function(){if(i>=o.length)return{done:true};return{done:false,value:o[i++]}}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}function _unsupportedIterableToArray(o,minLen){if(!o)return;if(typeof o==="string")return _arrayLikeToArray(o,minLen);var n=Object.prototype.toString.call(o).slice(8,-1);if(n==="Object"&&o.constructor)n=o.constructor.name;if(n==="Map"||n==="Set")return Array.from(o);if(n==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return _arrayLikeToArray(o,minLen)}function _arrayLikeToArray(arr,len){if(len==null||len>arr.length)len=arr.length;for(var i=0,arr2=new Array(len);i<len;i++){arr2[i]=arr[i]}return arr2}function _inheritsLoose(subClass,superClass){subClass.prototype=Object.create(superClass.prototype);subClass.prototype.constructor=subClass;_setPrototypeOf(subClass,superClass)}function _setPrototypeOf(o,p){_setPrototypeOf=Object.setPrototypeOf||function _setPrototypeOf(o,p){o.__proto__=p;return o};return _setPrototypeOf(o,p)}function _defineProperty(obj,key,value){if(key in obj){Object.defineProperty(obj,key,{value:value,enumerable:true,configurable:true,writable:true})}else{obj[key]=value}return obj}var Entity=function(_Glyph){_inheritsLoose(Entity,_Glyph);function Entity(options){var _this;_this=_Glyph.call(this,options)||this;_this._name=options["name"]||"";_this._x=options["x"]||0;_this._y=options["y"]||0;_this._z=options["z"]||0;_this._map=options["map"]||null;_this._mixins={};_this._mixinGroups={};_this.init(options);return _this}var _proto=Entity.prototype;_proto.init=function init(options){for(var _iterator=_createForOfIteratorHelperLoose(options["mixins"]||[]),_step;!(_step=_iterator()).done;){var mixin=_step.value;this._mixins[mixin.name]=true;if(mixin.group){this._mixinGroups[mixin.group]=true}for(var property in mixin){if(!(property in this)){this[property]=mixin[property]}}if(mixin.init){mixin.init.call(this,options)}}};_proto.hasMixin=function hasMixin(mixin){if(typeof mixin==="object"){return this._mixins[mixin.name]}else{return this._mixins[mixin]||this._mixinGroups[mixin]}};_proto.setName=function setName(name){this._name=name};_proto.setPos=function setPos(p){this._x=p.x;this._y=p.y};_proto.setX=function setX(x){this._x=x};_proto.setY=function setY(y){this._y=y};_proto.setZ=function setZ(z){this._z=z};_proto.name=function name(){return this._name};_proto.pos=function pos(){return{x:this._x,y:this._y}};_proto.x=function x(){return this._x};_proto.y=function y(){return this._y};_proto.z=function z(){return this._z};_proto.setMap=function setMap(map){this._map=map};_proto.map=function map(){return this._map};_proto.startOfTurn=function startOfTurn(){if(this.hasMixin("StatusEffects")){this.statusTick()}if(this.hasMixin("Regenerate")){this.regenTick()}if(this.hasMixin("Sensor")){this.sense()}};_proto.skipTurn=function skipTurn(){if(this.hasMixin("Regenerate")){this.regenTick()}};Entity.register=function register(template){Entity.Templates[template.name]=template};Entity.factory=function factory(name){if(!name||!Entity.Templates[name]){console.warn("no entity",name);return null}return new Entity(Entity.Templates[name])};return Entity}(Glyph);_defineProperty(Entity,"Mixins",{});_defineProperty(Entity,"Templates",{});Entity.Mixins.WalkMover={name:"WalkMover",group:"Mover",tryMove:function tryMove(dx,dy){var x=this.x()+dx;var y=this.y()+dy;return this.tryMoveTo(x,y)},tryMoveTo:function tryMoveTo(x,y){var tile=this.map().tile(x,y);var target=this.map().entityAt(x,y);if(target){if(this.hasMixin("Attacker")){return this.attack(target)}return false}if(tile.walkable()){this._x=x;this._y=y;return true}return false},pathPassable:function pathPassable(x,y){if(this.hasMixin("Attacker")&&this.hasMixin("Sensor")){var target=this.senseEntityAt(x,y);if(target&&target!==this&&this.isSameTeam(target)){return false}}return this.map().walkable(x,y)}};Entity.Mixins.Destructible={name:"Destructible",init:function init(options){this._mhp=options["mhp"]||10;this._hp=options["hp"]||this._mhp;this._onTakeDamage=(options["onTakeDamage"]||function(){}).bind(this)},hp:function hp(){return this._hp},setHp:function setHp(hp){this._hp=Math.min(hp,this.mhp())},mhp:function mhp(){return this._mhp},takeDamage:function takeDamage(attacker,damage){this._hp-=damage;this._onTakeDamage(attacker,damage);if(this._hp<=0&&!this.hasMixin("PlayerActor")){this.map().removeEntity(this);$game.player().onEntityDeath(this);return}if(attacker&&this.hasMixin("HuntBehaviour")){this.startHunting(attacker)}},gainHp:function gainHp(amount){this._hp+=amount;this._hp=Math.min(this._hp,this._mhp)},gainMhp:function gainMhp(amount){this._mhp+=amount;if(amount>0){this._hp+=amount}this._hp=Math.min(this._hp,this._mhp)},isDead:function isDead(){return this._hp<=0}};Entity.Mixins.Regenerate={name:"Regenerate",init:function init(options){this._regenRate=options["regen"]||.01;this._regenStock=0},regenTick:function regenTick(){this._regenStock+=this._regenRate*this.mhp();var r=Math.floor(this._regenStock);if(r>0){this.gainHp(r);this._regenStock-=r}}};Entity.Mixins.StatusEffects={name:"StatusEffects",init:function init(options){this._statuses=new Map},addStatus:function addStatus(id,turns){this._statuses.set(id,Math.max(this._statuses.get(id)||0,turns))},removeStatus:function removeStatus(id){this._statuses.delete(id);$game.log().addSelfMessage(this,"recover","fron "+id)},hasStatus:function hasStatus(id){return this._statuses.get(id)},statusTick:function statusTick(){if(this.hasStatus("poison")){this.gainHp(-1)}for(var _iterator2=_createForOfIteratorHelperLoose(this._statuses.keys()),_step2;!(_step2=_iterator2()).done;){var k=_step2.value;var turns=this._statuses.get(k)-1;if(turns>0){this._statuses.set(k,turns)}else{this.removeStatus(k)}}},statusLighting:function statusLighting(){var radius=12;var color=[240,240,200];if(this.hasStatus("poison")){color=[180,240,200]}if(this.hasStatus("darkness")){radius=3}if(this.hasMixin("Destructible")&&this.isDead()){color=[120,30,30];radius=6}return{r:radius,c:color}}};Entity.Mixins.StatusAttack={name:"StatusAttack",init:function init(options){this._statusAttackId=options["statusAttackId"];this._statusAttackTurns=options["statusAttackTurns"]||8;this._statusAttackChance=options["statusAttackChance"]||50},tryToInflictStatus:function tryToInflictStatus(target){if(!this._statusAttackId)return;if(ROT.RNG.getPercentage()<=this._statusAttackChance){target.addStatus(this._statusAttackId,Math.round(ROT.RNG.getNormal(1,.125)*this._statusAttackTurns));$game.log().addBattleMessage(this,target,"afflict","with "+this._statusAttackId)}}};Entity.Mixins.Stats={name:"Stats",init:function init(options){this._stats={};this._stats["acc"]=options["acc"]||80;this._stats["eva"]=options["eva"]||0;this._stats["atk"]=options["atk"]||1;this._stats["def"]=options["def"]||0;this._stats["snk"]=options["snk"]||0},addStat:function addStat(s,v){this._stats[s]+=v},acc:function acc(){return this._stats["acc"]},eva:function eva(){return this._stats["eva"]},atk:function atk(){return this._stats["atk"]},def:function def(){return this._stats["def"]},snk:function snk(){return this._stats["snk"]}};Entity.Mixins.SimpleAttacker={name:"SimpleAttacker",group:"Attacker",init:function init(options){this._team=options["team"]||"enemy"},team:function team(){return this._team},isSameTeam:function isSameTeam(entity){if(!entity.hasMixin("Attacker")){return false}return entity.team()==this.team()},attack:function attack(target){if(this.isSameTeam(target)){return false}if(target.hasMixin("Destructible")){if(this.hasMixin("Stats")&&target.hasMixin("Stats")){var toHit=this.acc()-target.eva();var toHitRoll=ROT.RNG.getPercentage();if(toHitRoll<toHit){$game.log().addBattleMessage(this,target,"hit")}else{if(toHitRoll<this.acc()){$game.log().addBattleMessage(target,this,"dodge")}else{$game.log().addBattleMessage(this,target,"miss")}return true}}var damage=1;if(this.hasMixin("Stats")){damage=ROT.RNG.getNormal(1,.1)*this.atk()}if(target.hasMixin("Stats")){damage-=ROT.RNG.getNormal(1,.1)*target.def()}damage=Math.max(1,Math.round(damage));target.takeDamage(this,damage);if(this.hasMixin("LifeSteal")){this.lifeSteal(target,damage)}if(this.hasMixin("StatusAttack")&&target.hasMixin("StatusEffects")){this.tryToInflictStatus(target)}return true}return false}};Entity.Mixins.RangedAttacker={name:"RangedAttacker",group:"Attacker",init:function init(options){this._rangedAttackCooldown=options["rangedAttackCooldown"]||5;this._rangedAttackMinRange=options["rangedAttackMinRange"]||2;this._rangedAttackCooldownCount=this._rangedAttackCooldown;this._rangedAttackVerb=options["rangedAttackVerb"]||"shoot";this._rangedAttackCallback=options["rangedAttackCallback"]||this.attack},useRangedAttack:function useRangedAttack(target){if(this._rangedAttackCooldown>this._rangedAttackCooldownCount){this._rangedAttackCooldownCount++;return false}if(this._rangedAttackMinRange>Math.max(Math.abs(target.x()-this.x()),Math.abs(target.y()-this.y()))){return false}if(this.hasMixin("Sensor")&&!this.canSense(target)){return false}this._rangedAttackCooldownCount=0;$game.log().addBattleMessage(this,target,this._rangedAttackVerb);return this._rangedAttackCallback.call(this,target)}};Entity.Mixins.LifeSteal={name:"LifeSteal",init:function init(options){this._lifeStealPercent=options["lifeStealPercent"]||100},lifeSteal:function lifeSteal(target,damage){if(this.hp()<this.mhp()){var v=Math.round(damage*this._lifeStealPercent*.01);if(v>0){this.gainHp(v);$game.log().addSelfMessage(this,"heal")}}}};Entity.Mixins.PlayerActor={name:"PlayerActor",group:"Actor",act:function act(){this.startOfTurn();if(this.isDead()){$game.log().addSelfMessage(this,"die")}$game.refresh();$game.engine().lock()},onEntityDeath:function onEntityDeath(entity){if(this.hasMixin("Sensor")&&this.canSense(entity)){$game.log().addSelfMessage(entity,"die")}else if(this.isSameTeam(entity)){$game.log().addMessage("You feel a sense of loss.")}else{$game.log().addMessage("You feel a sense of triumph.")}if(entity.hasMixin("Stats")){var xp=entity.mhp()*(1+entity.def());xp*=(100+entity.eva())/100;xp*=entity.atk()*entity.acc();this.gainXp(Math.ceil(xp/20))}}};Entity.Mixins.RandomActor={name:"RandomActor",group:"Actor",act:function act(){this.startOfTurn();if(this.hasMixin("Mover")){var dir=ROT.DIRS[8][Math.floor(ROT.RNG.getUniform()*ROT.DIRS[8].length)];this.tryMove.apply(this,dir.concat([this.map()]))}}};Entity.Mixins.ThoughtfulActor={name:"ThoughtfulActor",group:"Actor",act:function act(){try{if(this.map()!==$game.player().map()&&(!this.hasMixin("HuntBehaviour")||!this.isHunting())){return}this.startOfTurn();if(this.hasMixin("HuntBehaviour")){if(this.isHunting()||this.shouldStartHunting()){return this.hunt()}}if(this.hasMixin("WanderBehaviour")){this.wander()}}catch(e){console.error(e)}}};Entity.Mixins.HuntBehaviour={name:"HuntBehaviour",group:"Behaviour",init:function init(options){this.stopHunting()},shouldStartHunting:function shouldStartHunting(){if(this.hasMixin("Sensor")){var e=this.senseNearestEnemy();if(e){if($game.player().canSense(this)){$game.log().addBattleMessage(this,e,"spot")}this.startHunting(e);return true}}return false},startHunting:function startHunting(e){this._huntTarget={e:e,x:e.x(),y:e.y()}},stopHunting:function stopHunting(){this._huntTarget={e:null,x:0,y:0}},isHunting:function isHunting(){return this._huntTarget.e},hunt:function hunt(){var _this2=this;if(!this.hasMixin("Sensor")||this.canSense(this._huntTarget.e)){this._huntTarget.x=this._huntTarget.e.x();this._huntTarget.y=this._huntTarget.e.y()}if(this.hasMixin("RangedAttacker")&&this.useRangedAttack(this._huntTarget.e)){return}if(this.hasMixin("Mover")){var astar=new ROT.Path.AStar(this._huntTarget.x,this._huntTarget.y,(function(x,y){return _this2.pathPassable(x,y)}));var stepX=null;var stepY=null;astar.compute(this.x(),this.y(),(function(x,y){if(stepX===null&&(x!=_this2.x()||y!=_this2.y())){stepX=x;stepY=y}}));if(stepX===null){if(!this.hasMixin("Sensor")||!this.canSense(this._huntTarget.e)){console.log(this.name(),"gives up the hunt");this.stopHunting()}return false}return this.tryMoveTo(stepX,stepY)}}};Entity.Mixins.WanderBehaviour={name:"WanderBehaviour",group:"Behaviour",init:function init(options){this._wanderTarget=null;this._wanderPath=[]},wander:function wander(){var _this3=this;if(!this._wanderTarget){this._wanderTarget=this.map().getRandomTile(this.pathPassable.bind(this));console.log(this.name(),"is wandering to",this._wanderTarget)}if(!this.hasMixin("Mover")){throw new Error("WanderBehaviour assigned to entity without Mover")}var nextTile=this._wanderPath.shift();if(!nextTile||Math.abs(this.x()-nextTile.x)>1||Math.abs(this.y()-nextTile.y)>1){this._wanderPath=[];var astar=new ROT.Path.AStar(this._wanderTarget.x,this._wanderTarget.y,(function(x,y){return _this3.pathPassable(x,y)}));astar.compute(this.x(),this.y(),(function(x,y){_this3._wanderPath.push({x:x,y:y})}));this._wanderPath.shift();nextTile=this._wanderPath.shift()}if(nextTile&&this.tryMoveTo(nextTile.x,nextTile.y)){return true}else{this._wanderTarget=null;this._wanderPath=[];return false}}};Entity.Mixins.SightSensor={name:"SightSensor",group:"Sensor",init:function init(options){this._sightRadius=options["sightRadius"]||6;this._sensedEntities=new Map;this._sensedLocations=new Map},sense:function sense(){var _this4=this;this._sensedEntities.clear();this._sensedLocations.clear();this.map().fov().compute(this.x(),this.y(),this._sightRadius,(function(x,y,r,visibility){var e=_this4._map.entityAt(x,y);if(e){_this4._sensedEntities.set(e,{d:r,v:visibility});_this4._sensedLocations.set(x+","+y,e)}}))},canSense:function canSense(entity){return this._sensedEntities.get(entity)!==undefined},canSenseWithStealth:function canSenseWithStealth(entity){var e=this._sensedEntities.get(entity);if(e===undefined){return false}var chance=(.8*((this._sightRadius-e.d)/this._sightRadius)+.2)*e.v;if(entity.hasMixin("Stats")){chance*=(100-entity.snk())/100}return ROT.RNG.getUniform()<chance},senseNearestEnemy:function senseNearestEnemy(){var e=null;for(var _iterator3=_createForOfIteratorHelperLoose(this._sensedEntities.keys()),_step3;!(_step3=_iterator3()).done;){var k=_step3.value;if(!this.isSameTeam(k)&&this.canSenseWithStealth(k)){if(!e||this._sensedEntities[e].d>this._sensedEntities[k].d){e=k}}}return e},senseEntityAt:function senseEntityAt(x,y){return this._sensedLocations.get(x+","+y)}};var DefaultLevelUpTable=[{},{hp:5,acc:1,eva:1,snk:1},{hp:5,acc:1,eva:1,atk:1},{hp:5,acc:1,eva:1,snk:1},{hp:5,acc:1,eva:1,def:1},{hp:5,acc:1,eva:1,atk:1},{hp:5,acc:1,eva:1,snk:1},{hp:5,acc:1,eva:1,snk:1},{hp:5,acc:1,eva:1,atk:1},{hp:5,acc:1,eva:1,def:1},{hp:1}];Entity.Mixins.LevelUps={init:function init(options){this._level=options["level"]||1;this._xpExponent=options["xpExponent"]||1.7;this._xpFlat=options["xpFlat"]||2;this._xpMultiplier=options["xpMultiplier"]||40;this._xp=this.xpForLevel(this._level-1);this._levelUpTable=options["levelUpTable"]||DefaultLevelUpTable},xp:function xp(){return this._xp},level:function level(){return this._level},gainXp:function gainXp(xp){this._xp+=xp;while(this._xp>=this.xpForLevel(this._level)){this._level++;$game.log().addMessage("Welcome to level "+this._level+".");this.applyLevelChanges(this._level)}},xpForLevel:function xpForLevel(level){if(level<1)return 0;return Math.round((Math.pow(this._xpExponent,level)+this._xpFlat*level)*this._xpMultiplier)},applyLevelChanges:function applyLevelChanges(l){if(l>=this._levelUpTable.length)l=this._levelUpTable.length-1;var row=this._levelUpTable[l];for(var k in row){var v=row[k];if(k=="hp"){this.gainMhp(v)}else{this.addStat(k,v)}}}};Entity.Mixins.Inventory={init:function init(options){var startingItems=options["startingItems"]||[];this._items=new Array(20).fill(null);this._equips=new Map;this._gold=0;for(var _iterator4=_createForOfIteratorHelperLoose(startingItems),_step4;!(_step4=_iterator4()).done;){var i=_step4.value;var item=Item.factory(i);this.gainItem(item);if(item.hasMixin("Equip")){this.equipItem(item)}}},items:function items(){return this._items},gold:function gold(){return this._gold},gainItem:function gainItem(item){if(item.hasMixin("Treasure")){var v=item.value();$game.log().addMessage("The "+item.name()+" was worth "+v+" gold.");this._gold+=v;return-1}var j=this._items.findIndex((function(a){return!a}));if(j<0){$game.log().addMessage(item.name()+" tumbles from your pack.");this.dropItem(item)}else{this._items[j]=item;if(item.onPickup)item.onPickup(this)}return j},loseItem:function loseItem(item){var j=this._items.findIndex((function(a){return a===item}));this.loseItemInSlot(j)},loseItemInSlot:function loseItemInSlot(slot){if(slot<0)return;this._items[slot]=null},dropItem:function dropItem(item){this.loseItem(item);item.setPos(this.pos());this.map().addItem(item);if(item.onDrop)item.onDrop(this)},equipItem:function equipItem(item){for(var _iterator5=_createForOfIteratorHelperLoose(item.slots()),_step5;!(_step5=_iterator5()).done;){var slot=_step5.value;var other=this._equips.get(slot);if(other)this.unequipItem(other);this._equips.set(slot,item)}$game.log().addMessage("You equip "+item.name()+".");item.onEquip(this)},unequipItem:function unequipItem(item){for(var _iterator6=_createForOfIteratorHelperLoose(item.slots()),_step6;!(_step6=_iterator6()).done;){var slot=_step6.value;this._equips.delete(slot)}$game.log().addMessage("You unequip "+item.name()+".");item.onUnequip(this)},isItemEquipped:function isItemEquipped(item){for(var _iterator7=_createForOfIteratorHelperLoose(this._equips.values()),_step7;!(_step7=_iterator7()).done;){var eq=_step7.value;if(item===eq)return true}return false},pickupItem:function pickupItem(item){if(!item.hasMixin("Treasure")&&this._items.every((function(a){return a}))){$game.log().addMessage("Your inventory is full.");return false}this.map().removeItem(item);var slot=this.gainItem(item);if(slot>=0){$game.log().addMessage("You get "+item.name()+". ("+this.inventorySlotLetter(slot)+")")}},pickupTopItem:function pickupTopItem(){var item=this.map().topItemAt(this.x(),this.y());if(!item)return false;return this.pickupItem(item)},inventorySlotLetter:function inventorySlotLetter(slot){return String.fromCharCode(97+slot)}};"use strict";function _createForOfIteratorHelperLoose(o,allowArrayLike){var it=typeof Symbol!=="undefined"&&o[Symbol.iterator]||o["@@iterator"];if(it)return(it=it.call(o)).next.bind(it);if(Array.isArray(o)||(it=_unsupportedIterableToArray(o))||allowArrayLike&&o&&typeof o.length==="number"){if(it)o=it;var i=0;return function(){if(i>=o.length)return{done:true};return{done:false,value:o[i++]}}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}function _unsupportedIterableToArray(o,minLen){if(!o)return;if(typeof o==="string")return _arrayLikeToArray(o,minLen);var n=Object.prototype.toString.call(o).slice(8,-1);if(n==="Object"&&o.constructor)n=o.constructor.name;if(n==="Map"||n==="Set")return Array.from(o);if(n==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return _arrayLikeToArray(o,minLen)}function _arrayLikeToArray(arr,len){if(len==null||len>arr.length)len=arr.length;for(var i=0,arr2=new Array(len);i<len;i++){arr2[i]=arr[i]}return arr2}function _inheritsLoose(subClass,superClass){subClass.prototype=Object.create(superClass.prototype);subClass.prototype.constructor=subClass;_setPrototypeOf(subClass,superClass)}function _setPrototypeOf(o,p){_setPrototypeOf=Object.setPrototypeOf||function _setPrototypeOf(o,p){o.__proto__=p;return o};return _setPrototypeOf(o,p)}function _defineProperty(obj,key,value){if(key in obj){Object.defineProperty(obj,key,{value:value,enumerable:true,configurable:true,writable:true})}else{obj[key]=value}return obj}var Item=function(_Entity){_inheritsLoose(Item,_Entity);function Item(options){var _foreground;options[_foreground="foreground"]||(options[_foreground]="yellow");return _Entity.call(this,options)||this}Item.register=function register(template){Item.Templates[template.name]=template};Item.factory=function factory(name){if(!name||!Item.Templates[name]){console.warn("no item",name);return null}return new Item(Item.Templates[name])};return Item}(Entity);_defineProperty(Item,"Mixins",{});_defineProperty(Item,"Templates",{});Item.Mixins.Treasure={name:"Treasure",init:function init(options){this._value=Math.round(ROT.RNG.getNormal(1,.2)*(options["value"]||100))},value:function value(){return this._value}};Item.Mixins.Equip={name:"Equip",init:function init(options){this._stats=options["stats"]||{};this._slots=options["slots"]||[];this._equipCallback=(options["equipCallback"]||function(entity,onoff){}).bind(this)},slots:function slots(){return this._slots},onEquip:function onEquip(entity){this._equipCallback.call(entity,true);for(var k in this._stats){var v=this._stats[k];if(k=="hp"){entity.gainMhp(v)}else{entity.addStat(k,v)}}},onUnequip:function onUnequip(entity){for(var k in this._stats){var v=-this._stats[k];if(k=="hp"){entity.gainMhp(v)}else{entity.addStat(k,v)}}this._equipCallback.call(entity,false)}};Item.Mixins.Usable={name:"Usable",init:function init(options){this._onUse=(options["onUse"]||function(user){}).bind(this);this._consumable="consumable"in options?options["consumable"]:true},onUse:function onUse(entity){this._onUse(entity);if(this._consumable){entity.loseItem(this)}}};Item.Mixins.Artifact={name:"Artifact",init:function init(options){this._bearer=null},onPickup:function onPickup(bearer){this._bearer=bearer;$game.scheduler().add(this,true)},onDrop:function onDrop(bearer){$game.scheduler().remove(this);this._bearer=null},act:function act(){var _this=this;try{var _ret=function(){if(!_this._bearer)return{v:void 0};var map=_this._bearer.map();if(_this._bearer.z()==0&&map.tile(_this._bearer.x(),_this._bearer.y())===Tile.bridgeTile){$game.switchScreen(Screen_Win)}if(ROT.RNG.getPercentage()<92)return{v:void 0};var tiles=[];map.fov().compute(_this._bearer.x(),_this._bearer.y(),_this._bearer._sightRadius,(function(x,y,r,visibility){if(map.walkable(x,y)){tiles.push({x:x,y:y})}}));tiles=ROT.RNG.shuffle(tiles);var target=null;var _loop=function _loop(){var tile=_step.value;if(tile.x==_this._bearer.x()&&tile.y==_this._bearer.y()){return"continue"}var astar=new ROT.Path.AStar(_this._bearer.x(),_this._bearer.y(),(function(x,y){if(x==tile.x&&y==tile.y)return false;return map.walkable(x,y)}));var steps=0;astar.compute(map.entry().x,map.entry().y,(function(x,y){steps++}));if(steps>0){target=tile;return"break"}};for(var _iterator=_createForOfIteratorHelperLoose(tiles),_step;!(_step=_iterator()).done;){var _ret2=_loop();if(_ret2==="continue")continue;if(_ret2==="break")break}if(!target)return{v:void 0};map.setTile(target.x,target.y,Tile.crystalWallTile);$game.log().addMessage("A column of blue crystal surges out of the ground.");for(var _iterator2=_createForOfIteratorHelperLoose(map.itemsAt(target.x,target.y)),_step2;!(_step2=_iterator2()).done;){var item=_step2.value;map.removeItem(item)}var entity=map.entityAt(target.x,target.y);if(entity&&entity.hasMixin("Destructible")){$game.log().addBattleMessage("column",entity,"obliterate");map.removeEntity(entity)}for(var x=-1;x<=1;x++){for(var y=-1;y<=1;y++){entity=map.entityAt(x+target.x,y+target.y);if(entity&&entity.hasMixin("Destructible")){var damage=12;if(entity.hasMixin("Stats")){if(ROT.RNG.getPercentage()<=entity.eva()){$game.log().addSelfMessage(entity,"dodge","flying shards");continue}damage=Math.max(1,damage-entity.def())}$game.log().addBattleMessage("flying shards",entity,"lacerate");entity.takeDamage(null,damage)}}}}();if(typeof _ret==="object")return _ret.v}catch(e){console.error(e)}}};"use strict";function _defineProperty(obj,key,value){if(key in obj){Object.defineProperty(obj,key,{value:value,enumerable:true,configurable:true,writable:true})}else{obj[key]=value}return obj}var EncounterTable=function(){function EncounterTable(table){table||(table={});this._items=table["items"]||{gold:1};this._entities=table["entities"]||{slime:1};this._level=0}EncounterTable.setLevelTable=function setLevelTable(level,table){EncounterTable._levels[level]=new EncounterTable(table);table._level=level};EncounterTable.getLevelTable=function getLevelTable(level){var _EncounterTable$_leve;(_EncounterTable$_leve=EncounterTable._levels)[level]||(_EncounterTable$_leve[level]=new EncounterTable);return EncounterTable._levels[level]};var _proto=EncounterTable.prototype;_proto.draw=function draw(subtable){var encounter=ROT.RNG.getWeightedValue(this[subtable]);if(encounter==="OUT_OF_DEPTH"){return EncounterTable.getLevelTable(this._level+1).draw(subtable)}return encounter};_proto.drawEntity=function drawEntity(){return Entity.factory(this.draw("_entities"))};_proto.drawItem=function drawItem(){return Item.factory(this.draw("_items"))};return EncounterTable}();_defineProperty(EncounterTable,"_levels",[]);"use strict";function _createForOfIteratorHelperLoose(o,allowArrayLike){var it=typeof Symbol!=="undefined"&&o[Symbol.iterator]||o["@@iterator"];if(it)return(it=it.call(o)).next.bind(it);if(Array.isArray(o)||(it=_unsupportedIterableToArray(o))||allowArrayLike&&o&&typeof o.length==="number"){if(it)o=it;var i=0;return function(){if(i>=o.length)return{done:true};return{done:false,value:o[i++]}}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}function _unsupportedIterableToArray(o,minLen){if(!o)return;if(typeof o==="string")return _arrayLikeToArray(o,minLen);var n=Object.prototype.toString.call(o).slice(8,-1);if(n==="Object"&&o.constructor)n=o.constructor.name;if(n==="Map"||n==="Set")return Array.from(o);if(n==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return _arrayLikeToArray(o,minLen)}function _arrayLikeToArray(arr,len){if(len==null||len>arr.length)len=arr.length;for(var i=0,arr2=new Array(len);i<len;i++){arr2[i]=arr[i]}return arr2}var Game_Map=function(){function Game_Map(tiles){this._tiles=tiles;this._width=tiles.length;this._height=tiles[0].length;this._entry=null;this._exit=null;this._rooms=[];this._entities=[];this._items=[];this._fov=new ROT.FOV.PreciseShadowcasting(this.lightPasses.bind(this));this._explored=new Array(this._width);for(var x=0;x<this._width;x++){this._explored[x]=new Array(this._height).fill(Tile.nullTile)}}var _proto=Game_Map.prototype;_proto.width=function width(){return this._width};_proto.height=function height(){return this._height};_proto.isOutOfBounds=function isOutOfBounds(x,y){return x<0||x>=this._width||y<0||y>=this._height};_proto.tile=function tile(x,y){if(this.isOutOfBounds(x,y)){return Tile.nullTile}return this._tiles[x][y]||Tile.nullTile};_proto.setTile=function setTile(x,y,tile){if(this.isOutOfBounds(x,y)){console.warn("setTile out of bounds",x,y);return}this._tiles[x][y]=tile};_proto.blitTiles=function blitTiles(src,dx,dy,w,h,sx,sy){sx||(sx=0);sy||(sy=0);w||(w=src.width());h||(h=src.height());for(var x=0;x<w;x++){for(var y=0;y<h;y++){var tile=src.tile(x+sx,y+sy);if(tile!=Tile.nullTile){this.setTile(x+dx,y+dy,tile)}}}};_proto.explore=function explore(x,y){if(this.isOutOfBounds(x,y)){return}this._explored[x][y]=this.tile(x,y)};_proto.exploreAll=function exploreAll(){for(var x=0;x<this._width;x++){for(var y=0;y<this._height;y++){if(this.tile(x,y).walkable()||!this.tile(x,y).opaque()){for(var x2=-1;x2<=1;x2++){for(var y2=-1;y2<=1;y2++){this.explore(x+x2,y+y2)}}}}}};_proto.getExploredTile=function getExploredTile(x,y){if(this.isOutOfBounds(x,y)){return Tile.nullTile}return this._explored[x][y]};_proto.setEntry=function setEntry(p){this._entry=p};_proto.setExit=function setExit(p){this._exit=p};_proto.entry=function entry(){return this._entry};_proto.exit=function exit(){return this._exit};_proto.entities=function entities(){return this._entities};_proto.entityAt=function entityAt(x,y){for(var _iterator=_createForOfIteratorHelperLoose(this.entities()),_step;!(_step=_iterator()).done;){var entity=_step.value;if(entity.x()==x&&entity.y()==y){return entity}}return null};_proto.addEntity=function addEntity(e){if(e.x()<0||e.x()>=this._width||e.y()<0||e.y()>=this._height){throw new Error("entity out of bounds")}e.setMap(this);this._entities.push(e);if(e.hasMixin("Actor")){$game.scheduler().add(e,true)}};_proto.removeEntity=function removeEntity(e){var pos=this._entities.indexOf(e);if(pos>=0){this._entities.splice(pos,1)}if(e.hasMixin("Actor")){$game.scheduler().remove(e)}};_proto.addEntityAtRandomPosition=function addEntityAtRandomPosition(e){var p=this.getRandomFloorTileInAnyRoom();e.setPos(p);this.addEntity(e)};_proto.items=function items(){return this._items};_proto.itemsAt=function itemsAt(x,y){return this.items().filter((function(i){return i.x()==x&&i.y()==y}))};_proto.topItemAt=function topItemAt(x,y){return this.items().find((function(i){return i.x()==x&&i.y()==y}))};_proto.addItem=function addItem(e){if(e.x()<0||e.x()>=this._width||e.y()<0||e.y()>=this._height){throw new Error("item out of bounds")}e.setMap(this);this._items.push(e)};_proto.removeItem=function removeItem(e){var pos=this._items.indexOf(e);if(pos>=0){this._items.splice(pos,1)}};_proto.addItemAtRandomPosition=function addItemAtRandomPosition(e){var p=this.getRandomFloorTileInAnyRoom();e.setPos(p);this.addItem(e)};_proto.getRandomTile=function getRandomTile(predicate){var p={x:0,y:0};do{p.x=Math.floor(ROT.RNG.getUniform()*this._width);p.y=Math.floor(ROT.RNG.getUniform()*this._height)}while(!predicate(p.x,p.y));return p};_proto.isOpenFloorTile=function isOpenFloorTile(x,y){return this.tile(x,y).walkable()&&!this.entityAt(x,y)};_proto.getRandomFloorTile=function getRandomFloorTile(){return this.getRandomTile(this.isOpenFloorTile.bind(this))};_proto.getRandomFloorTileBeside=function getRandomFloorTileBeside(tx,ty){var choices=[];for(var x=-1;x<=1;x++){for(var y=-1;y<=1;y++){if(this.isOpenFloorTile(tx+x,ty+y))choices.push({x:tx+x,y:ty+y})}}return ROT.RNG.getItem(choices)};_proto.setRooms=function setRooms(rooms){this._rooms=rooms.slice()};_proto.getRooms=function getRooms(){return this._rooms};_proto.getRandomFloorTileInAnyRoom=function getRandomFloorTileInAnyRoom(){var rooms=this.getRooms;if(!rooms.length){return this.getRandomFloorTile()}var limit=1e3;while(limit>0){limit--;var room=rooms[Math.floor(ROT.RNG.getUniform()*rooms.length)];var x=room.getLeft();var y=room.getTop();x+=Math.round(ROT.RNG.getUniform()*(room.getRight()-x));y+=Math.round(ROT.RNG.getUniform()*(room.getBottom()-y));if(this.tile(x,y).walkable()&&!this.entityAt(x,y)){return{x:x,y:y}}}return this.getRandomFloorTile()};_proto.walkable=function walkable(x,y){return this.tile(x,y).walkable()};_proto.swimable=function swimable(x,y){return this.tile(x,y).swimable()};_proto.flyable=function flyable(x,y){return this.tile(x,y).flyable()};_proto.lightPasses=function lightPasses(x,y){return this.entityAt(x,y)||!this.tile(x,y).opaque()};_proto.lightReflects=function lightReflects(x,y){return this.tile(x,y).reflectivity()};_proto.fov=function fov(){return this._fov};Game_Map.fromString=function fromString(str){var rows=str.split("\n");var map=new Array(rows[0].length);for(var y=0;y<rows.length;y++){for(var x=0;x<rows[y].length;x++){var _x;map[_x=x]||(map[_x]=new Array(rows.length));map[x][y]=Tile.catalogue[rows[y][x]]||Tile.nullTile}}return new Game_Map(map)};return Game_Map}();"use strict";function _defineProperty(obj,key,value){if(key in obj){Object.defineProperty(obj,key,{value:value,enumerable:true,configurable:true,writable:true})}else{obj[key]=value}return obj}var MessageLog=function(){function MessageLog(){this.clear()}var _proto=MessageLog.prototype;_proto.clear=function clear(){this._log=[];this._backlog=[]};_proto.addMessage=function addMessage(str){this._log.push(str)};_proto.getMessage=function getMessage(){var msg=this._log.shift();if(msg!==undefined){this._backlog.push(msg);if(this._backlog.length>MessageLog.BACKLOG_SIZE){this._backlog.shift()}}return msg};_proto.getBacklog=function getBacklog(){return this._backlog};_proto.peekMessageLen=function peekMessageLen(){var msg=this._log[0];return msg===undefined?0:msg.length};_proto.hasMore=function hasMore(){return this._log.length>0};_proto.make_article=function make_article(entity,caps){var name=typeof entity==="string"?entity:entity.name();if(name[0]==name[0].toUpperCase()){return name}return(caps?"The ":"the ")+name};_proto.make_verb=function make_verb(subject,verb){if(typeof subject==="object"&&subject.hasMixin("PlayerActor")){return verb}if(verb.endsWith("s")){return verb+"es"}else{return verb+"s"}};_proto.addBattleMessage=function addBattleMessage(subject,object,verb,phrase){this.addMessage(this.make_article(subject,true)+" "+this.make_verb(subject,verb)+" "+this.make_article(object)+(phrase?" "+phrase:"")+".")};_proto.addSelfMessage=function addSelfMessage(subject,verb,phrase){this.addMessage(this.make_article(subject,true)+" "+this.make_verb(subject,verb)+(phrase?" "+phrase:"")+".")};return MessageLog}();_defineProperty(MessageLog,"BACKLOG_SIZE",24);"use strict";function _defineProperty(obj,key,value){if(key in obj){Object.defineProperty(obj,key,{value:value,enumerable:true,configurable:true,writable:true})}else{obj[key]=value}return obj}function _createForOfIteratorHelperLoose(o,allowArrayLike){var it=typeof Symbol!=="undefined"&&o[Symbol.iterator]||o["@@iterator"];if(it)return(it=it.call(o)).next.bind(it);if(Array.isArray(o)||(it=_unsupportedIterableToArray(o))||allowArrayLike&&o&&typeof o.length==="number"){if(it)o=it;var i=0;return function(){if(i>=o.length)return{done:true};return{done:false,value:o[i++]}}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}function _unsupportedIterableToArray(o,minLen){if(!o)return;if(typeof o==="string")return _arrayLikeToArray(o,minLen);var n=Object.prototype.toString.call(o).slice(8,-1);if(n==="Object"&&o.constructor)n=o.constructor.name;if(n==="Map"||n==="Set")return Array.from(o);if(n==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return _arrayLikeToArray(o,minLen)}function _arrayLikeToArray(arr,len){if(len==null||len>arr.length)len=arr.length;for(var i=0,arr2=new Array(len);i<len;i++){arr2[i]=arr[i]}return arr2}function _inheritsLoose(subClass,superClass){subClass.prototype=Object.create(superClass.prototype);subClass.prototype.constructor=subClass;_setPrototypeOf(subClass,superClass)}function _setPrototypeOf(o,p){_setPrototypeOf=Object.setPrototypeOf||function _setPrototypeOf(o,p){o.__proto__=p;return o};return _setPrototypeOf(o,p)}var Screen=function(){function Screen(){}var _proto=Screen.prototype;_proto.enter=function enter(){console.log("enter",this)};_proto.exit=function exit(){console.log("exit",this)};_proto.render=function render(display){};_proto.handleInput=function handleInput(inputType,inputData){};_proto.drawCentered=function drawCentered(display,y,msg,color){color||(color="");display.drawText(Math.floor((display.getOptions().width-msg.length)/2),y,color+msg)};return Screen}();var Screen_Title=function(_Screen){_inheritsLoose(Screen_Title,_Screen);function Screen_Title(){return _Screen.apply(this,arguments)||this}var _proto2=Screen_Title.prototype;_proto2.render=function render(display){var title1=[" _______","/__  __/___ ____ ____ ____ ___   _____ ____ _____","  / / / __// __// __// __// _ | / _  // __//_  _/"," / / / __//__ //__ // __// _  // _  // /_   / /","/_/ /___//___//___//___//_//_//_//_//___/  /_/"];var title2=["   ______","  / ___  |_  _ ____ ____ _____"," / /  / /// /// __// __//_  _/","/ /\\\\/ ///_/// __//__ /  / /","|___\\\\//___//___//___/  /_/"];for(var y=0;y<title1.length;y++){for(var x=0;x<title1[y].length;x++){display.draw(x+16,y+8,title1[y][x],"cyan","black")}}for(var _y=0;_y<title2.length;_y++){for(var _x=0;_x<title2[_y].length;_x++){var c=title2[_y][_x];if(c!==" "){display.draw(_x+24,_y+12,c,"magenta","black")}}}this.drawCentered(display,display.getOptions().height-2,"Press Enter to Start","%c{yellow}")};_proto2.handleInput=function handleInput(inputType,inputData){if(inputType=="keydown"){switch(inputData.keyCode){case ROT.KEYS.VK_RETURN:$game.switchScreen(Screen_Play);break;default:break}}};return Screen_Title}(Screen);var Screen_Play=function(_Screen2){_inheritsLoose(Screen_Play,_Screen2);function Screen_Play(){return _Screen2.apply(this,arguments)||this}var _proto3=Screen_Play.prototype;_proto3.enter=function enter(){_Screen2.prototype.enter.call(this);var displayOptions=$game.display().getOptions();var width=displayOptions.width;var height=displayOptions.height-2;this._dungeonLevels=new Array(11);var architect=new Architect({style:"woods",width:width,height:height,encounterTable:EncounterTable.getLevelTable(0),enemyCount:10,itemCount:2});this._dungeonLevels[0]=architect.build();for(var i=1;i<10;i++){architect=new Architect({style:"dungeon",width:width,height:height,spawnNear:this._dungeonLevels[i-1].exit(),encounterTable:EncounterTable.getLevelTable(i)});this._dungeonLevels[i]=architect.build()}architect=new Architect({style:"boss",width:width,height:height,spawnNear:this._dungeonLevels[9].exit()});this._dungeonLevels[10]=architect.build();this._dungeonLevels[10].addItemAtRandomPosition(Item.factory("Tesseract"));this._map=this._dungeonLevels[0];this._player=new Entity(Entity.Templates.Player);this._player.setPos(this._map.entry());this._player.setZ(0);this._map.addEntity(this._player);$game.setDungeon(this._dungeonLevels);$game.setPlayer(this._player);$game.engine().start();$game.switchScreen(Screen_Map)};return Screen_Play}(Screen);var Screen_Game=function(_Screen3){_inheritsLoose(Screen_Game,_Screen3);function Screen_Game(){return _Screen3.apply(this,arguments)||this}var _proto4=Screen_Game.prototype;_proto4.enter=function enter(){_Screen3.prototype.enter.call(this);var displayOptions=$game.display().getOptions();this._freezeLog=false;this._logArea={x:0,y:0,width:displayOptions.width,height:1};this._statsArea={x:0,y:displayOptions.height-1,width:displayOptions.width,height:1};this._player=$game.player()};_proto4.renderStats=function renderStats(display){var statsText="HP: ";var hpratio=this._player.hp()/this._player.mhp();if(hpratio<=.25){statsText+="%b{#800000}"+this._player.hp()+"/"+this._player.mhp()+"%b{black}"}else if(hpratio<=.6){statsText+="%c{yellow}"+this._player.hp()+"%c{white}"+"/"+this._player.mhp()}else{statsText+=this._player.hp()+"/"+this._player.mhp()}statsText+=" ACC: "+this._player.acc();statsText+=" EVA: "+this._player.eva();statsText+=" ATK: "+this._player.atk();statsText+=" DEF: "+this._player.def();statsText+=" SNK: "+this._player.snk();statsText+=" LV: "+this._player.level();statsText+=" XP: "+this._player.xp()+"/"+this._player.xpForLevel(this._player.level());statsText+=" Depth: "+this._player.z();display.drawText(this._statsArea.x,this._statsArea.y,statsText,this._statsArea.width)};_proto4.renderLog=function renderLog(display){if(this._freezeLog){return}var moreText="--MORE--";for(var y=0;y<this._logArea.height;y++){var max=this._logArea.width;if(y==this._logArea.height-1){max-=moreText.length}for(var x=0;x+$game.log().peekMessageLen()<max;){var msg=$game.log().getMessage();if(!msg)break;display.drawText(this._logArea.x+x,this._logArea.y+y,msg);x+=msg.length+1}if(!$game.log().hasMore()){break}}if($game.log().hasMore()){display.drawText(this._logArea.x+this._logArea.width-moreText.length,this._logArea.height-1,"%c{black}%b{white}"+moreText)}};return Screen_Game}(Screen);var Screen_Map=function(_Screen_Game){_inheritsLoose(Screen_Map,_Screen_Game);function Screen_Map(){return _Screen_Game.apply(this,arguments)||this}var _proto5=Screen_Map.prototype;_proto5.enter=function enter(){_Screen_Game.prototype.enter.call(this);var displayOptions=$game.display().getOptions();this._freezeLog=false;this._viewPort={x:0,y:this._logArea.height,width:displayOptions.width,height:displayOptions.height-(this._logArea.height+this._statsArea.height)};this._dungeonLevels=$game.dungeon();this._map=this._dungeonLevels[this._player.z()]};_proto5.exit=function exit(){_Screen_Game.prototype.exit.call(this)};_proto5.render=function render(display){this.renderViewPort(display);this.renderLog(display);this.renderStats(display)};_proto5.renderViewPort=function renderViewPort(display){var _this=this;for(var x=0;x<this._map.width();x++){for(var y=0;y<this._map.height();y++){var glyph=this._map.getExploredTile(x,y);var color=[40,40,120];var fg=ROT.Color.multiply(color,ROT.Color.fromString(glyph.foreground()));var bg=ROT.Color.multiply(color,ROT.Color.fromString(glyph.background()));display.draw(this._viewPort.x+x,this._viewPort.y+y,glyph.char(),ROT.Color.toRGB(fg),ROT.Color.toRGB(bg))}}var statusLight=this._player.statusLighting();var lighting=new ROT.Lighting(this._map.lightReflects.bind(this._map),{range:statusLight.r,passes:2});lighting.setFOV(this._map.fov());lighting.setLight(this._player.x(),this._player.y(),statusLight.c);lighting.compute((function(x,y,color){var color2=ROT.Color.add(ROT.Color.multiply(color,[224,224,224]),[32,32,32]);var glyph=_this._map.entityAt(x,y)||_this._map.topItemAt(x,y)||_this._map.tile(x,y);var fg=ROT.Color.multiply(color2,ROT.Color.fromString(glyph.foreground()));var bg=ROT.Color.multiply(color2,ROT.Color.fromString(glyph.background()));display.draw(_this._viewPort.x+x,_this._viewPort.y+y,glyph.char(),ROT.Color.toRGB(fg),ROT.Color.toRGB(bg));_this._map.explore(x,y)}))};_proto5.renderAllEntities=function renderAllEntities(display){for(var _iterator=_createForOfIteratorHelperLoose(this._map.entities()),_step;!(_step=_iterator()).done;){var entity=_step.value;display.draw.apply(display,[this._viewPort.x+entity.x(),this._viewPort.y+entity.y()].concat(entity.drawp()))}};_proto5.move=function move(dx,dy){if(this._player.tryMove(dx,dy,this._map)){this._player.pickupTopItem();this._freezeLog=true;$game.refresh();this._freezeLog=false;$game.engine().unlock()}};_proto5.skipTurn=function skipTurn(){this._player.skipTurn();$game.log().addMessage("You rest.");$game.engine().unlock()};_proto5.useStairsDown=function useStairsDown(){var tile=this._map.tile(this._player.x(),this._player.y());if(tile!==Tile.stairsDownTile){$game.log().addMessage("There is no stairs down here.");$game.refresh();return}$game.log().addSelfMessage(this._player,"descend");var z=this._player.z()+1;this._player.setZ(z);this._map.removeEntity(this._player);this._map=this._dungeonLevels[z];this._map.addEntity(this._player);this._player.setPos(this._map.entry());this._freezeLog=true;$game.refresh();this._freezeLog=false;$game.engine().unlock()};_proto5.useStairsUp=function useStairsUp(){var tile=this._map.tile(this._player.x(),this._player.y());if(tile!==Tile.stairsUpTile){$game.log().addMessage("There is no stairs up here.");$game.refresh();return}$game.log().addSelfMessage(this._player,"ascend");var z=this._player.z()-1;this._player.setZ(z);this._map.removeEntity(this._player);this._map=this._dungeonLevels[z];this._map.addEntity(this._player);this._player.setPos(this._map.exit());this._freezeLog=true;$game.refresh();this._freezeLog=false;$game.engine().unlock()};_proto5.getItem=function getItem(){if(this._player.pickupTopItem()){this._freezeLog=true;$game.refresh();this._freezeLog=false;$game.engine().unlock()}else{$game.refresh()}};_proto5.handleInput=function handleInput(inputType,inputData){if(inputType=="keydown"){if($game.log().hasMore()){$game.refresh();return}if(this._player.isDead()){$game.switchScreen(Screen_Lose);return}switch(inputData.keyCode){case ROT.KEYS.VK_NUMPAD1:case ROT.KEYS.VK_END:case ROT.KEYS.VK_Z:this.move(-1,1);break;case ROT.KEYS.VK_NUMPAD2:case ROT.KEYS.VK_DOWN:case ROT.KEYS.VK_X:this.move(0,1);break;case ROT.KEYS.VK_NUMPAD3:case ROT.KEYS.VK_PAGE_DOWN:case ROT.KEYS.VK_C:this.move(1,1);break;case ROT.KEYS.VK_NUMPAD4:case ROT.KEYS.VK_LEFT:case ROT.KEYS.VK_A:this.move(-1,0);break;case ROT.KEYS.VK_NUMPAD5:case ROT.KEYS.VK_S:this.skipTurn();break;case ROT.KEYS.VK_NUMPAD6:case ROT.KEYS.VK_RIGHT:case ROT.KEYS.VK_D:this.move(1,0);break;case ROT.KEYS.VK_NUMPAD7:case ROT.KEYS.VK_HOME:case ROT.KEYS.VK_Q:this.move(-1,-1);break;case ROT.KEYS.VK_NUMPAD8:case ROT.KEYS.VK_UP:case ROT.KEYS.VK_W:this.move(0,-1);break;case ROT.KEYS.VK_NUMPAD9:case ROT.KEYS.VK_PAGE_UP:case ROT.KEYS.VK_E:this.move(1,-1);break;case ROT.KEYS.VK_GREATER_THAN:case ROT.KEYS.VK_PERIOD:this.useStairsDown();break;case ROT.KEYS.VK_LESS_THAN:case ROT.KEYS.VK_COMMA:this.useStairsUp();break;case ROT.KEYS.VK_G:this.getItem();break;case ROT.KEYS.VK_I:case ROT.KEYS.VK_SPACE:case ROT.KEYS.VK_ENTER:$game.switchScreen(Screen_Inventory);break;case ROT.KEYS.VK_QUESTION_MARK:case ROT.KEYS.VK_SLASH:case ROT.KEYS.VK_ESCAPE:$game.switchScreen(Screen_Help);break;case ROT.KEYS.VK_M:$game.switchScreen(Screen_MessageLog);break;default:break}}};return Screen_Map}(Screen_Game);var Screen_Help=function(_Screen_Game2){_inheritsLoose(Screen_Help,_Screen_Game2);function Screen_Help(){return _Screen_Game2.apply(this,arguments)||this}var _proto6=Screen_Help.prototype;_proto6.enter=function enter(){_Screen_Game2.prototype.enter.call(this);var displayOptions=$game.display().getOptions()};_proto6.render=function render(display){this.drawCentered(display,0,"How To Play","%c{goldenrod}");this.drawCentered(display,2,"QWE               789","%c{cyan}");this.drawCentered(display,3,"A D               4 6","%c{cyan}");this.drawCentered(display,3,"Movement Keys","%c{white}");this.drawCentered(display,4,"ZXC               123","%c{cyan}");display.drawText(1,6,"To %c{goldenrod}attack%c{white} a monster, try to move onto it.");display.drawText(1,7,"Press %c{cyan}S%c{white}, or %c{cyan}5%c{white} to rest for a turn.");display.drawText(1,8,"Press %c{cyan}space%c{white}, %c{cyan}enter%c{white} or %c{cyan}I%c{white} to open your inventory.");display.drawText(1,9,"Press %c{cyan}<%c{white}, %c{cyan},%c{white}, %c{cyan}>%c{white} or %c{cyan}.%c{white} to use stairs.");display.drawText(1,10,"Press %c{cyan}G%c{white} to pick up an item.");display.drawText(1,11,"Press %c{cyan}M%c{white} to review message backlog.");this.drawCentered(display,13,"Map Key","%c{goldenrod}");display.drawText(1,15,"%c{brown}r %c{white}b - ordinary monsters, red in tooth and claw");display.drawText(1,16,"%c{pink}S %c{purple}F %c{white}- dangerous monsters, with special attacks");display.drawText(1,17,"%c{yellow}* %c{white}  - treasure (collect for score)");display.drawText(1,18,"%c{yellow}/[]%c{white} - equipment (equip from inventory)");display.drawText(1,19,"%c{red}! %c{yellow}$%c{white} - consumables (use from inventory)");display.drawText(1,20,"%c{cyan}&   %c{white}- Quest Item (bring back to your boat to win)");display.drawText(0,22,"%c{goldenrod}ACC%c{white}: hit more %c{goldenrod}EVA%c{white}: be hit less %c{goldenrod}ATK%c{white}: hit harder %c{goldenrod}DEF%c{white}: reduce damage %c{goldenrod}SNK%c{white}: sneaking");this.renderStats(display)};_proto6.handleInput=function handleInput(inputType,inputData){if(inputType=="keydown"){$game.switchScreen(Screen_Map)}};return Screen_Help}(Screen_Game);var Screen_MessageLog=function(_Screen_Game3){_inheritsLoose(Screen_MessageLog,_Screen_Game3);function Screen_MessageLog(){return _Screen_Game3.apply(this,arguments)||this}var _proto7=Screen_MessageLog.prototype;_proto7.enter=function enter(){_Screen_Game3.prototype.enter.call(this);var displayOptions=$game.display().getOptions()};_proto7.render=function render(display){var y=0;for(var _iterator2=_createForOfIteratorHelperLoose($game.log().getBacklog()),_step2;!(_step2=_iterator2()).done;){var msg=_step2.value;display.drawText(0,y,msg);y++}this.renderStats(display)};_proto7.handleInput=function handleInput(inputType,inputData){if(inputType=="keydown"){$game.switchScreen(Screen_Map)}};return Screen_MessageLog}(Screen_Game);var Screen_Inventory=function(_Screen_Game4){_inheritsLoose(Screen_Inventory,_Screen_Game4);function Screen_Inventory(){return _Screen_Game4.apply(this,arguments)||this}var _proto8=Screen_Inventory.prototype;_proto8.enter=function enter(){_Screen_Game4.prototype.enter.call(this);var displayOptions=$game.display().getOptions();this._inventoryArea={x:1,y:2,width:displayOptions.width,height:displayOptions.height-2};this._promptArea={x:0,y:displayOptions.height-2,width:displayOptions.width,height:1};this._state=Screen_Inventory.PICK_ITEM;this._selectedItem=null};_proto8.renderInventoryPanel=function renderInventoryPanel(display){var items=this._player.items();var height=items.reduce((function(p,c){return p+(c?1:0)}),0);if(!height){display.drawText(this._inventoryArea.x,this._inventoryArea.y,"Your inventory is empty.");return}var i=0;for(var y=0;y<height;y++){while(!items[i]&&i<items.length){i++}if(!items[i])break;var eq=this._player.isItemEquipped(items[i]);var decor_name="%c{yellow}"+String.fromCharCode(97+i)+"%c{white}";decor_name+=eq?"> ":") ";decor_name+=" %c{"+items[i].foreground()+"}"+items[i].char();decor_name+=" %c{white}"+items[i].name();if(items[i].hasMixin("Equip")){decor_name+=(eq?" (equipped as %c{yellow}":" (%c{gray}")+items[i].slots().join(", ")+"%c{white})"}display.drawText(this._inventoryArea.x,this._inventoryArea.y+y,decor_name);i++}};_proto8.renderPromptArea=function renderPromptArea(display){var prompt="";switch(this._state){case Screen_Inventory.PICK_ITEM:prompt="Choose an item with its letter, or %c{yellow}Escape%c{white} to close inventory.";break;case Screen_Inventory.PICK_ACTION:var actions=["%c{yellow}d%c{white}rop"];if(this._selectedItem&&this._selectedItem.hasMixin("Equip")){actions.push("%c{yellow}e%c{white}quip")}if(this._selectedItem&&this._selectedItem.hasMixin("Usable")){actions.push("%c{yellow}u%c{white}se")}actions.push("or %c{yellow}Escape%c{white} to pick a different item.");prompt=this._selectedItem.name()+": "+actions.join(", ");break}display.drawText(this._promptArea.x,this._promptArea.y,prompt,this._promptArea.width)};_proto8.render=function render(display){this.renderInventoryPanel(display);this.renderPromptArea(display);this.renderStats(display);this.renderLog(display)};_proto8.handleInput=function handleInput(inputType,inputData){if(inputType=="keydown"){if(this._state==Screen_Inventory.PICK_ITEM){if(inputData.keyCode==ROT.KEYS.VK_ESCAPE){$game.switchScreen(Screen_Map)}else if(inputData.keyCode>=ROT.KEYS.VK_A&&inputData.keyCode<=ROT.KEYS.VK_T){this._selectedItem=this._player.items()[inputData.keyCode-ROT.KEYS.VK_A];if(this._selectedItem){this._state=Screen_Inventory.PICK_ACTION;$game.refresh()}}}else if(this._state==Screen_Inventory.PICK_ACTION){switch(inputData.keyCode){case ROT.KEYS.VK_ESCAPE:this.pickNewItem();break;case ROT.KEYS.VK_D:this.dropItem();break;case ROT.KEYS.VK_E:this.equipItem();break;case ROT.KEYS.VK_U:this.useItem();break}}else{$game.switchScreen(Screen_Map)}}};_proto8.dropItem=function dropItem(){if(!this._selectedItem)return;if(this._player.isItemEquipped(this._selectedItem)){this._player.unequipItem(this._selectedItem)}this._player.dropItem(this._selectedItem);this.pickNewItem();$game.refresh()};_proto8.equipItem=function equipItem(){if(!this._selectedItem)return;if(this._player.isItemEquipped(this._selectedItem)){this._player.unequipItem(this._selectedItem)}else if(this._selectedItem.hasMixin("Equip")){this._player.equipItem(this._selectedItem)}this.pickNewItem();$game.refresh()};_proto8.useItem=function useItem(){if(!this._selectedItem)return;if(this._selectedItem.hasMixin("Usable")){this._selectedItem.onUse(this._player)}$game.switchScreen(Screen_Map);$game.engine().unlock()};_proto8.pickNewItem=function pickNewItem(){this._selectedItem=null;this._state=Screen_Inventory.PICK_ITEM;$game.refresh()};return Screen_Inventory}(Screen_Game);_defineProperty(Screen_Inventory,"PICK_ITEM",0);_defineProperty(Screen_Inventory,"PICK_ACTION",1);var Screen_GameEnd=function(_Screen4){_inheritsLoose(Screen_GameEnd,_Screen4);function Screen_GameEnd(){return _Screen4.apply(this,arguments)||this}var _proto9=Screen_GameEnd.prototype;_proto9.enter=function enter(){_Screen4.prototype.enter.call(this);this._player=$game.player();$game.scheduler().clear();$game.setPlayer(null)};_proto9.handleInput=function handleInput(inputType,inputData){if(inputType=="keydown"){switch(inputData.keyCode){case ROT.KEYS.VK_RETURN:$game.switchScreen(Screen_Title);break;default:break}}};return Screen_GameEnd}(Screen);var Screen_Win=function(_Screen_GameEnd){_inheritsLoose(Screen_Win,_Screen_GameEnd);function Screen_Win(){return _Screen_GameEnd.apply(this,arguments)||this}var _proto10=Screen_Win.prototype;_proto10.render=function render(display){this.drawCentered(display,2,"You escaped the dungeon with the Tesseract!","%c{goldenrod}");var win=[[5,"+___________+"],[4,"/:\\         ,:\\"],[3,"/ : \\       , : \\"],[2,"/  :  \\     ,  :  \\"],[1,"/   :   +-----------+"],[0,"+....:../:...+   :  /|"],[0,"|\\   +./.:...`...+ / |"],[0,"| \\ ,`/  :   :` ,`/  |"],[0,"|  \\ /`. :   : ` /`  |"],[0,"| , +-----------+  ` |"],[0,"|,  |   `+...:,.|...`+"],[0,"+...|...,'...+  |   /"],[1,"\\  |  ,     `  |  /"],[2,"\\ | ,       ` | /"],[3,"\\|,         `|/   %c{white}mn, 7/97"],[4,"+___________+"]];for(var y=0;y<win.length;y++){display.drawText(29+win[y][0],y+5,"%c{cyan}"+win[y][1])}var score=1e4;display.drawText(1,4,"Victory:        "+String(score).padStart(5," "));display.drawText(1,5,"XP Earned:      "+String(this._player.xp()).padStart(5," "));display.drawText(1,6,"Treasure Found: "+String(this._player.gold()).padStart(5," "));score+=this._player.xp()+this._player.gold();display.drawText(1,8,"Score:         "+String(score).padStart(6," "));this.drawCentered(display,display.getOptions().height-2,"Press Enter to Play Again","%c{yellow}")};return Screen_Win}(Screen_GameEnd);var Screen_Lose=function(_Screen_GameEnd2){_inheritsLoose(Screen_Lose,_Screen_GameEnd2);function Screen_Lose(){return _Screen_GameEnd2.apply(this,arguments)||this}var _proto11=Screen_Lose.prototype;_proto11.render=function render(display){this.drawCentered(display,2,"Game Over","%c{goldenrod}");var gameover=[[12,"_"],[11,"//"],[10,"%c{cyan}=~"],[9,"// %c{cyan}~~"],[5,"___//__  %c{cyan}~~"],[4,"/_    _/"],[5,"/   /"],[4,"/   /"],[3,"/   /"],[2,"/   /"],[1,"/   /"],[0,'%c{green}""""""']];for(var y=0;y<gameover.length;y++){display.drawText(32+gameover[y][0],y+7,gameover[y][1])}var score=this._player.z()*100;display.drawText(1,3,"Depth (x100):   "+String(score).padStart(5," "));display.drawText(1,4,"XP Earned:      "+String(this._player.xp()).padStart(5," "));display.drawText(1,5,"Treasure Found: "+String(this._player.gold()).padStart(5," "));score+=this._player.xp()+this._player.gold();display.drawText(1,7,"Score:         "+String(score).padStart(6," "));this.drawCentered(display,display.getOptions().height-2,"Press Enter to Try Again","%c{yellow}")};return Screen_Lose}(Screen_GameEnd);"use strict";function _inheritsLoose(subClass,superClass){subClass.prototype=Object.create(superClass.prototype);subClass.prototype.constructor=subClass;_setPrototypeOf(subClass,superClass)}function _setPrototypeOf(o,p){_setPrototypeOf=Object.setPrototypeOf||function _setPrototypeOf(o,p){o.__proto__=p;return o};return _setPrototypeOf(o,p)}function _defineProperty(obj,key,value){if(key in obj){Object.defineProperty(obj,key,{value:value,enumerable:true,configurable:true,writable:true})}else{obj[key]=value}return obj}var Tile=function(_Glyph){_inheritsLoose(Tile,_Glyph);function Tile(options){var _this;_this=_Glyph.call(this,options)||this;_this._passable="passable"in options?options["passable"]:false;_this._opaque="opaque"in options?options["opaque"]:true;_this._reflectivity="reflectivity"in options?options["reflectivity"]:_this._opaque?.3:0;return _this}var _proto=Tile.prototype;_proto.passable=function passable(){return this._passable};_proto.walkable=function walkable(){return this._passable};_proto.swimable=function swimable(){return this._swimable};_proto.flyable=function flyable(){return this._swimable||this._passable};_proto.opaque=function opaque(){return this._opaque};_proto.reflectivity=function reflectivity(){return this._reflectivity};return Tile}(Glyph);_defineProperty(Tile,"nullTile",new Tile({}));_defineProperty(Tile,"floorTile",new Tile({char:"·",passable:true,opaque:false}));_defineProperty(Tile,"wallTile",new Tile({char:"#"}));_defineProperty(Tile,"doorTile",new Tile({char:"+",passable:true}));_defineProperty(Tile,"waterTile",new Tile({char:"≈",foreground:"blue",opaque:false}));_defineProperty(Tile,"stairsUpTile",new Tile({char:"<",passable:true,opaque:false}));_defineProperty(Tile,"stairsDownTile",new Tile({char:">",passable:true,opaque:false}));_defineProperty(Tile,"bridgeTile",new Tile({char:"=",foreground:"brown",passable:true,opaque:false}));_defineProperty(Tile,"grassTile",new Tile({char:"„",foreground:"#66CC33",passable:true,opaque:false}));_defineProperty(Tile,"treeTile",new Tile({char:"↑",foreground:"#11DD44"}));_defineProperty(Tile,"sandTile",new Tile({char:"·",foreground:"#de9714",passable:true,opaque:false}));_defineProperty(Tile,"crystalWallTile",new Tile({char:"#",foreground:"cyan"}));_defineProperty(Tile,"fancyWallTiles",[new Tile({char:"□"}),new Tile({char:"═"}),new Tile({char:"║"}),new Tile({char:"╔"}),new Tile({char:"╗"}),new Tile({char:"╚"}),new Tile({char:"╝"}),new Tile({char:"╠"}),new Tile({char:"╣"}),new Tile({char:"╩"}),new Tile({char:"╦"}),new Tile({char:"╬"})]);_defineProperty(Tile,"catalogue",{".":Tile.floorTile,"#":Tile.wallTile,"~":Tile.waterTile,"<":Tile.stairsUpTile,">":Tile.stairsDownTile});"use strict";Item.register({name:"dagger",char:"/",stats:{atk:1,eva:3,acc:3},slots:["weapon"],mixins:[Item.Mixins.Equip]});Item.register({name:"club",char:"/",stats:{atk:2},slots:["weapon"],mixins:[Item.Mixins.Equip]});Item.register({name:"spear",char:"/",stats:{atk:3},slots:["weapon","shield"],mixins:[Item.Mixins.Equip]});Item.register({name:"rapier",char:"/",stats:{atk:2,eva:5,acc:5},slots:["weapon"],mixins:[Item.Mixins.Equip]});Item.register({name:"warhammer",char:"/",stats:{atk:3},slots:["weapon"],mixins:[Item.Mixins.Equip]});Item.register({name:"bill hook",char:"/",stats:{atk:5},slots:["weapon","shield"],mixins:[Item.Mixins.Equip]});Item.register({name:"epee",char:"/",stats:{atk:3,eva:7,acc:10},slots:["weapon"],mixins:[Item.Mixins.Equip]});Item.register({name:"scimitar",char:"/",stats:{atk:5},slots:["weapon"],mixins:[Item.Mixins.Equip]});Item.register({name:"halberd",char:"/",stats:{atk:7},slots:["weapon","shield"],mixins:[Item.Mixins.Equip]});Item.register({name:"buckler",char:"]",foreground:"yellow",stats:{eva:20},slots:["shield"],mixins:[Item.Mixins.Equip]});Item.register({name:"round shield",char:"]",foreground:"yellow",stats:{eva:30},slots:["shield"],mixins:[Item.Mixins.Equip]});Item.register({name:"kite shield",char:"]",foreground:"yellow",stats:{eva:40,acc:-5},slots:["shield"],mixins:[Item.Mixins.Equip]});Item.register({name:"tower shield",char:"]",foreground:"yellow",stats:{eva:50,acc:-15},slots:["shield"],mixins:[Item.Mixins.Equip]});Item.register({name:"padded gambeson",char:"[",foreground:"yellow",stats:{def:1},slots:["body"],mixins:[Item.Mixins.Equip]});Item.register({name:"leather cuirass",char:"[",foreground:"yellow",stats:{def:2},slots:["body"],mixins:[Item.Mixins.Equip]});Item.register({name:"mail hauberk",char:"[",foreground:"yellow",stats:{def:3,snk:-10},slots:["body"],mixins:[Item.Mixins.Equip]});Item.register({name:"steel plate",char:"[",foreground:"yellow",stats:{def:3,snk:-20},slots:["body"],mixins:[Item.Mixins.Equip]});Item.register({name:"silver",char:"*",foreground:"white",background:"black",value:30,mixins:[Item.Mixins.Treasure]});Item.register({name:"gold",char:"*",foreground:"yellow",background:"black",mixins:[Item.Mixins.Treasure]});Item.register({name:"emerald",char:"*",foreground:"green",background:"black",value:300,mixins:[Item.Mixins.Treasure]});Item.register({name:"ruby",char:"*",foreground:"red",background:"black",value:500,mixins:[Item.Mixins.Treasure]});Item.register({name:"sapphire",char:"*",foreground:"blue",background:"black",value:700,mixins:[Item.Mixins.Treasure]});Item.register({name:"potion",char:"!",foreground:"red",onUse:function onUse(target){target.gainHp(10)},mixins:[Item.Mixins.Usable]});Item.register({name:"antidote",char:"!",foreground:"green",onUse:function onUse(target){target.removeStatus("poison")},mixins:[Item.Mixins.Usable]});Item.register({name:"eye drops",char:"!",foreground:"cyan",onUse:function onUse(target){target.removeStatus("darkness")},mixins:[Item.Mixins.Usable]});Item.register({name:"map",char:"$",foreground:"yellow",onUse:function onUse(target){target.map().exploreAll()},mixins:[Item.Mixins.Usable]});Item.register({name:"Tesseract",char:"&",foreground:"cyan",mixins:[Item.Mixins.Artifact]});Entity.Templates.Player={name:"You",char:"@",foreground:"white",background:"black",team:"player",startingItems:["dagger"],mixins:[Entity.Mixins.SightSensor,Entity.Mixins.WalkMover,Entity.Mixins.PlayerActor,Entity.Mixins.SimpleAttacker,Entity.Mixins.Destructible,Entity.Mixins.Stats,Entity.Mixins.Regenerate,Entity.Mixins.Inventory,Entity.Mixins.LevelUps,Entity.Mixins.StatusEffects]};Entity.register({name:"armadillo",char:"a",foreground:"goldenrod",background:"black",mhp:3,def:5,mixins:[Entity.Mixins.SightSensor,Entity.Mixins.WalkMover,Entity.Mixins.ThoughtfulActor,Entity.Mixins.SimpleAttacker,Entity.Mixins.Destructible,Entity.Mixins.Stats,Entity.Mixins.HuntBehaviour,Entity.Mixins.WanderBehaviour]});Entity.register({name:"bat",char:"b",foreground:"white",background:"black",mhp:1,eva:20,mixins:[Entity.Mixins.SightSensor,Entity.Mixins.WalkMover,Entity.Mixins.ThoughtfulActor,Entity.Mixins.SimpleAttacker,Entity.Mixins.Destructible,Entity.Mixins.Stats,Entity.Mixins.HuntBehaviour,Entity.Mixins.WanderBehaviour]});Entity.register({name:"centipede",char:"c",foreground:"orange",background:"black",mhp:12,def:1,atk:6,mixins:[Entity.Mixins.SightSensor,Entity.Mixins.WalkMover,Entity.Mixins.ThoughtfulActor,Entity.Mixins.SimpleAttacker,Entity.Mixins.Destructible,Entity.Mixins.Stats,Entity.Mixins.HuntBehaviour,Entity.Mixins.WanderBehaviour]});Entity.register({name:"jaguar",char:"j",foreground:"gray",background:"black",mhp:18,atk:4,mixins:[Entity.Mixins.SightSensor,Entity.Mixins.WalkMover,Entity.Mixins.ThoughtfulActor,Entity.Mixins.SimpleAttacker,Entity.Mixins.Destructible,Entity.Mixins.Stats,Entity.Mixins.HuntBehaviour,Entity.Mixins.WanderBehaviour]});Entity.register({name:"moth",char:"m",foreground:"brown",background:"black",mhp:12,eva:30,atk:6,mixins:[Entity.Mixins.SightSensor,Entity.Mixins.WalkMover,Entity.Mixins.ThoughtfulActor,Entity.Mixins.SimpleAttacker,Entity.Mixins.Destructible,Entity.Mixins.Stats,Entity.Mixins.HuntBehaviour,Entity.Mixins.WanderBehaviour]});Entity.register({name:"rat",char:"r",foreground:"brown",background:"black",mhp:1,mixins:[Entity.Mixins.SightSensor,Entity.Mixins.WalkMover,Entity.Mixins.ThoughtfulActor,Entity.Mixins.SimpleAttacker,Entity.Mixins.Destructible,Entity.Mixins.Stats,Entity.Mixins.HuntBehaviour,Entity.Mixins.WanderBehaviour]});Entity.register({name:"slime",char:"s",foreground:"cyan",background:"black",def:3,hp:16,onTakeDamage:function onTakeDamage(attacker,damage){if(!this.map()||this.hp()<2)return;var p=this.map().getRandomFloorTileBeside(this.x(),this.y());if(!p)return;var clone=Entity.factory(this.name());clone.setHp(Math.floor(this.hp()/2));this.setHp(Math.ceil(this.hp()/2));clone.setPos(p);this.map().addEntity(clone);$game.log().addSelfMessage(this,"split")},mixins:[Entity.Mixins.SightSensor,Entity.Mixins.WalkMover,Entity.Mixins.ThoughtfulActor,Entity.Mixins.SimpleAttacker,Entity.Mixins.Destructible,Entity.Mixins.Stats,Entity.Mixins.HuntBehaviour,Entity.Mixins.WanderBehaviour]});Entity.register({name:"mimic",char:"*",foreground:"goldenrod",background:"black",mhp:3,def:5,statusAttackId:"poison",mixins:[Entity.Mixins.SightSensor,Entity.Mixins.WalkMover,Entity.Mixins.ThoughtfulActor,Entity.Mixins.SimpleAttacker,Entity.Mixins.Destructible,Entity.Mixins.Stats,Entity.Mixins.HuntBehaviour,Entity.Mixins.StatusAttack]});Entity.register({name:"troll",char:"t",foreground:"orange",background:"black",mhp:40,def:1,atk:8,mixins:[Entity.Mixins.SightSensor,Entity.Mixins.WalkMover,Entity.Mixins.ThoughtfulActor,Entity.Mixins.SimpleAttacker,Entity.Mixins.Destructible,Entity.Mixins.Stats,Entity.Mixins.HuntBehaviour,Entity.Mixins.WanderBehaviour,Entity.Mixins.Regenerate]});Entity.register({name:"gray wolf",char:"w",foreground:"gray",background:"black",mhp:8,atk:3,mixins:[Entity.Mixins.SightSensor,Entity.Mixins.WalkMover,Entity.Mixins.ThoughtfulActor,Entity.Mixins.SimpleAttacker,Entity.Mixins.Destructible,Entity.Mixins.Stats,Entity.Mixins.HuntBehaviour,Entity.Mixins.WanderBehaviour]});Entity.register({name:"timber wolf",char:"w",foreground:"brown",background:"black",mhp:4,atk:2,mixins:[Entity.Mixins.SightSensor,Entity.Mixins.WalkMover,Entity.Mixins.ThoughtfulActor,Entity.Mixins.SimpleAttacker,Entity.Mixins.Destructible,Entity.Mixins.Stats,Entity.Mixins.HuntBehaviour,Entity.Mixins.WanderBehaviour]});Entity.register({name:"centaur",char:"C",foreground:"brown",background:"black",mhp:14,atk:5,mixins:[Entity.Mixins.SightSensor,Entity.Mixins.WalkMover,Entity.Mixins.ThoughtfulActor,Entity.Mixins.SimpleAttacker,Entity.Mixins.RangedAttacker,Entity.Mixins.Destructible,Entity.Mixins.Stats,Entity.Mixins.HuntBehaviour,Entity.Mixins.WanderBehaviour]});Entity.register({name:"incubus",char:"I",foreground:"red",background:"black",mhp:14,atk:8,rangedAttackVerb:"beckon",rangedAttackCallback:function rangedAttackCallback(target){var p=this.map().getRandomFloorTileBeside(this.x(),this.y());if(!p)return false;target.setPos(p);return true},mixins:[Entity.Mixins.SightSensor,Entity.Mixins.WalkMover,Entity.Mixins.ThoughtfulActor,Entity.Mixins.SimpleAttacker,Entity.Mixins.RangedAttacker,Entity.Mixins.Destructible,Entity.Mixins.Stats,Entity.Mixins.HuntBehaviour,Entity.Mixins.WanderBehaviour]});Entity.register({name:"coral snake",char:"S",foreground:"pink",background:"black",mhp:4,atk:2,statusAttackId:"poison",mixins:[Entity.Mixins.SightSensor,Entity.Mixins.WalkMover,Entity.Mixins.ThoughtfulActor,Entity.Mixins.SimpleAttacker,Entity.Mixins.Destructible,Entity.Mixins.Stats,Entity.Mixins.HuntBehaviour,Entity.Mixins.WanderBehaviour,Entity.Mixins.StatusAttack]});Entity.register({name:"filth fungus",char:"F",foreground:"purple",background:"black",mhp:14,atk:2,statusAttackId:"darkness",statusAttackChance:10,statusAttackTurns:30,mixins:[Entity.Mixins.SightSensor,Entity.Mixins.WalkMover,Entity.Mixins.ThoughtfulActor,Entity.Mixins.SimpleAttacker,Entity.Mixins.Destructible,Entity.Mixins.Stats,Entity.Mixins.HuntBehaviour,Entity.Mixins.WanderBehaviour,Entity.Mixins.StatusAttack]});Entity.register({name:"vampire",char:"V",foreground:"purple",background:"black",mhp:18,atk:7,rangedAttackVerb:"taunt",rangedAttackCooldown:3,rangedAttackMinRange:0,rangedAttackCallback:function rangedAttackCallback(target){var p=this.map().getRandomFloorTileBeside(target.x(),target.y());if(!p)return false;var minion=EncounterTable.getLevelTable(3).drawEntity();minion.setPos(p);this.map().addEntity(minion);$game.log().addSelfMessage(minion,"appear");return true},mixins:[Entity.Mixins.SightSensor,Entity.Mixins.WalkMover,Entity.Mixins.ThoughtfulActor,Entity.Mixins.LifeSteal,Entity.Mixins.SimpleAttacker,Entity.Mixins.RangedAttacker,Entity.Mixins.Destructible,Entity.Mixins.Stats,Entity.Mixins.HuntBehaviour,Entity.Mixins.WanderBehaviour]});EncounterTable.setLevelTable(0,{items:{silver:10,club:4,spear:4,buckler:4,"padded gambeson":4,OUT_OF_DEPTH:1},entities:{rat:3,bat:2,"timber wolf":2,OUT_OF_DEPTH:1}});EncounterTable.setLevelTable(1,{items:{silver:6,gold:4,club:2,spear:2,buckler:2,"padded gambeson":2,potion:3,antidote:2,"eye drops":2,map:1,OUT_OF_DEPTH:1},entities:{rat:4,bat:2,"gray wolf":1,OUT_OF_DEPTH:1}});EncounterTable.setLevelTable(2,{items:{silver:3,gold:6,emerald:1,club:2,spear:2,buckler:2,"padded gambeson":2,potion:3,antidote:2,"eye drops":2,map:1,OUT_OF_DEPTH:1},entities:{rat:2,bat:1,"gray wolf":2,armadillo:2,"coral snake":1,"filth fungus":1,OUT_OF_DEPTH:1}});EncounterTable.setLevelTable(3,{items:{silver:1,gold:5,emerald:1,ruby:1,rapier:1,club:1,spear:1,"round shield":1,"leather cuirass":1,potion:5,antidote:3,"eye drops":3,map:1,OUT_OF_DEPTH:1},entities:{slime:2,centipede:1,"gray wolf":2,armadillo:2,"coral snake":1,"filth fungus":2,OUT_OF_DEPTH:1}});EncounterTable.setLevelTable(4,{items:{sapphire:1,gold:5,emerald:1,ruby:1,rapier:1,warhammer:1,"bill hook":1,"round shield":1,"leather cuirass":1,potion:5,antidote:3,"eye drops":3,map:1,OUT_OF_DEPTH:1},entities:{slime:2,centipede:2,jaguar:2,troll:1,"coral snake":1,"filth fungus":2,OUT_OF_DEPTH:1}});EncounterTable.setLevelTable(5,{items:{sapphire:1,gold:4,emerald:2,ruby:1,rapier:1,warhammer:1,"bill hook":1,"round shield":1,"leather cuirass":1,potion:5,antidote:3,"eye drops":3,map:1,OUT_OF_DEPTH:1},entities:{slime:2,centipede:2,jaguar:2,troll:1,"coral snake":1,mimic:1,"filth fungus":2,OUT_OF_DEPTH:1}});EncounterTable.setLevelTable(6,{items:{sapphire:1,gold:3,emerald:2,ruby:2,epee:1,warhammer:1,"bill hook":1,"round shield":1,"mail hauberk":1,potion:5,antidote:3,"eye drops":3,map:1,OUT_OF_DEPTH:1},entities:{slime:2,centipede:2,jaguar:2,troll:1,mimic:1,moth:2,centaur:1,"coral snake":1,"filth fungus":2,OUT_OF_DEPTH:1}});EncounterTable.setLevelTable(7,{items:{sapphire:2,gold:2,emerald:2,ruby:2,epee:1,scimitar:1,"bill hook":1,"kite shield":1,"mail hauberk":1,potion:5,antidote:3,"eye drops":3,map:1,OUT_OF_DEPTH:1},entities:{slime:2,centipede:2,jaguar:2,troll:1,"coral snake":1,mimic:1,moth:2,centaur:2,incubus:1,"filth fungus":2,OUT_OF_DEPTH:1}});EncounterTable.setLevelTable(8,{items:{sapphire:2,gold:2,emerald:2,ruby:2,epee:1,scimitar:1,halberd:1,"tower shield":1,"steel plate":1,potion:5,antidote:3,"eye drops":3,map:1,OUT_OF_DEPTH:1},entities:{slime:2,centipede:2,jaguar:2,troll:1,mimic:1,centaur:2,incubus:2,vampire:2,"filth fungus":2,OUT_OF_DEPTH:1}});EncounterTable.setLevelTable(9,{items:{sapphire:2,gold:2,emerald:2,ruby:2,epee:1,scimitar:1,halberd:1,"tower shield":1,"steel plate":1,potion:5,antidote:3,"eye drops":3,map:1},entities:{slime:2,centipede:2,jaguar:2,mimic:1,troll:1,incubus:3,vampire:2,"filth fungus":2}});